% Convolution: The process of applying a filter to an image is usually referred to as convolution

clear all; close all

ima = imread('Lena.PNG');
ima = mean(ima,3);

subplot(2,2,1)
imagesc(ima)
colormap(gray(256))


%% Convolution with a low pass filter. kernel of 3 x 3

filterblur1=ones(3,3) % this is a kernel of 3 x 3 ones

imablur1=convn(ima,filterblur1); % the image value are no longuer in the range 0 and 255.
% thus is due to the multiplicity and adding to the convolution
imablur1=imablur1./9; % devide by the block size to rectify the situation

subplot(2,2,2)
image(uint8(imablur1)); %this is a very slightly low pass filtering version of the image

%% Exercice: What happened when you try a more radical low pass filtering?

k=20;
filterblur1=ones(k,k);
imablur1=(convn(ima,filterblur1))./k^2; 
subplot(2,2,3)
image(uint8(imablur1)); 


